{**************************************************************************}
procedure GraphInit;    {initialize graphics mode}
var
    GraphDriver,GraphMode,GraphError:integer;

begin
     DetectGraph(GraphDriver,GraphMode);
     if (graphdriver<>VGA) or (graphmode<>VGAHi) then
        begin
        writeln('Sorry! Your computer doesn''t have a VGA graphics');
        writeln('card or monitor, which you need to play Pac-Tank...');
        halt(1);
        end;
     InitGraph(GraphDriver,GraphMode,'');
     GraphError:=GraphResult;
     if GraphError <> grOk then
        if grapherror=-3 then
           begin
           writeln('Pac-Tank could not find the EGAVGA.BGI file necessary');
           writeln('for its graphics operations. Make sure it is in the');
           writeln('same directory as PACTANK.EXE.');
           halt(2);
           end
        else
           begin
           WRITELN('Pac-Tank experienced an unusual graphics initialization');
           writeln('error. Code: ',grapherror:2);
           writeln('Message: ',GraphErrorMsg(GraphError));
           halt(3);
           end; {else}
end; {graphinit}
{**************************************************************************}

{**************************************************************************}
procedure setupcrypt(var letters:letterarray);
 var
   counter:longint;
   letter : string;
   goodletter:char;

 begin

   for counter := 1 to 26 do
       letters[1,counter] := chr(counter+64);

  for counter := 1 to 26 do
       letters[1,counter+26] := chr(counter+96);

  for counter := 0 to 9 do
      begin
       str(counter,letter);
       goodletter := letter[1];
       letters[1,counter+53] := goodletter;
      end;

  {set up jumbled alphabet}
  letters[2,1] := '8';  letters[2,2] := 'E';  letters[2,3] :='U';
  letters[2,4] := 'n';  letters[2,5] := 'w';  letters[2,6] :='O';
  letters[2,7] := 'v';  letters[2,8] := 'h';  letters[2,9] :='y';
  letters[2,10] :='e';  letters[2,11] :='u';  letters[2,12] :='T';
  letters[2,13] :='X';  letters[2,14] :='o';  letters[2,15] :='A';
  letters[2,16] :='M';  letters[2,17] :='f';  letters[2,18] :='G';
  letters[2,19] :='P';  letters[2,20] :='J';  letters[2,21] :='x';
  letters[2,22] :='R';  letters[2,23] :='m';  letters[2,24] :='k';
  letters[2,25] :='d';  letters[2,26] :='K';  letters[2,27] :='7';
  letters[2,28] :='j';  letters[2,29] :='2';  letters[2,30] :='1';
  letters[2,31] :='D';  letters[2,32] :='5';  letters[2,33] :='l';
  letters[2,34] :='S';  letters[2,35] :='4';  letters[2,36] :='Z';
  letters[2,37] :='9';  letters[2,38] :='C';  letters[2,39] :='b';
  letters[2,40] :='s';  letters[2,41] :='W';  letters[2,42] :='a';
  letters[2,43] :='L';  letters[2,44] :='Q';  letters[2,45] :='N';
  letters[2,46] :='6';  letters[2,47] :='0';  letters[2,48] :='p';
  letters[2,49] :='H';  letters[2,50] :='i';  letters[2,51] :='I';
  letters[2,52] :='F';  letters[2,53] :='z';  letters[2,54] :='3';
  letters[2,55] :='V';  letters[2,56] :='g';  letters[2,57] :='Y';
  letters[2,58] :='B';  letters[2,59] :='q';  letters[2,60] :='c';
  letters[2,61] :='t';  letters[2,62] :='r';
 end;
{**************************************************************************}
{**************************************************************************}
procedure encrypt(filename:string);
 var
     letter:char;
     letters:letterarray;
     word,badword:string;
     indata,outdata:text;
     counter,counter2,letternum:longint;
     found:boolean;

  begin
    setupcrypt(letters);
    assign(indata,filename);
    reset(indata);
    assign(outdata,'temp.tmp');
    rewrite(outdata);
    repeat
       badword:='';  letternum := 1;
       readln(indata,word);
       repeat
          counter := 1; found := false;
             repeat
               if word[letternum] = letters[1,counter] then
                  begin
                     badword := badword + letters[2,counter];
                     found := true;
                  end;
             counter := counter+1;
             until counter = 63;
             if found = false then badword := badword + word[letternum];
             found := false;
         letternum := letternum +1;
       until letternum = length(word)+1;
       writeln(outdata,badword);
    until EOF(indata);
    close(indata);
    close(outdata);
    erase(indata);
    rename(outdata,filename);
  end;   {procedure}
{**************************************************************************}
{**************************************************************************}
procedure unencrypt(filename:string);
 var
     letter:char;
     letters:letterarray;
     word,badword:string;
     indata,outdata:text;
     counter2,counter,letternum:longint;
     found:boolean;

  begin
    setupcrypt(letters);
    assign(indata,filename);
    reset(indata);
    assign(outdata,'temp.tmp');
    rewrite(outdata);
    repeat
       badword:='';  letternum := 1;
       readln(indata,word);
       repeat
          counter := 1;found := false;
             repeat
               if word[letternum] = letters[2,counter] then
                  begin
                     badword := badword + letters[1,counter];
                     found:=true;
                  end;
             counter := counter+1;
             until counter = 63;
             if found = false then badword := badword + word[letternum];
             found := false;
         letternum := letternum +1;
       until letternum = length(word)+1;
       writeln(outdata,badword);
    until EOF(indata);
    close(indata);
    close(outdata);
    erase(indata);
    rename(outdata,filename);
  end;   {procedure}
{***************************************************************************}
{**************************************************************************}
procedure loaddef;

    {loads default values}
  var
     file1,file2:string;
     indata1,indata2:text;
     counter,IOR:integer;

  begin
  {$I-}
     assign(indata1,'filename.ply');
     reset(indata1);
     close(indata1);
     IOR:=IOResult;
     if IOR=0 then
           begin
           assign(indata1,'filename.ply');
           reset(indata1);
           readln(indata1,names[1]);
           readln(indata1,file1);
           readln(indata1);
           readln(indata1,names[2]);
           readln(indata1,file2);
           close(indata1);
           IOR:=IOResult;
           if IOR=0 then
             begin
             assign(indata1,file1);
             assign(indata2,file2);
             reset(indata1);
             reset(indata2);
             close(indata1);
             close(indata2);
             IOR:=IOResult;
             if IOR=0 then
               begin
               unencrypt(file1);
               unencrypt(file2);
               assign(indata1,file1);
               assign(indata2,file2);
               reset(indata1);
               reset(indata2);
               IOR:=IOResult;
               if IOR=0 then
                 begin
                 for counter :=1 to 4 do
                    begin
                    readln(indata1);
                    readln(indata2);
                    end;
                 for Counter := 1 to 5 do
                    begin
                    readln(indata1,stat[Counter,1]);
                    readln(indata2,stat[Counter,2]);
                    end;
                 readln(indata1,hits[1,1]);
                 readln(indata1,hits[1,2]);
                 readln(indata2,hits[2,1]);
                 readln(indata2,hits[2,2]);
                 close(indata1);
                 close(indata2);
                 IOR:=IOResult;
                 if IOR=0 then
                   begin
                   encrypt(file1);
                   encrypt(file2);
                   end;
                 end;
               end;
             end;
           end;
     if ior<>0 then
        ErrorFlag:=True
     else
        ErrorFlag:=False;
   {$I+}
  end;
{**************************************************************************}
{**************************************************************************}
function getpassword(x,y:longint): String;
  var
   password:string;
   InputChar:char;
   exit : boolean;

  begin
     password := '';  exit := false;
  repeat
    if keypressed then
      InputChar := readkey
    else
      InputChar := ' ';
    InputChar := readkey;
    case InputChar of
     #8:begin
           delete(password,length(password),1);
           if x >= 2 then x := x - 1;
           gotoxy(x,y);
           write(' ');
           gotoxy(x,y);
         end;
     #13:exit := true;

     else
        begin
          gotoxy(x,y);
          write('*');
          password := password + InputChar;
          x := x + 1;
        end;
    end;    {case}

  until exit = true;
  getpassword := password;
  end;

{**************************************************************************}
{**************************************************************************}
procedure newrecord(player:longint;
                    left:longint);
  var     {make a new record}
     ok,password,filename,codename,lllk,winloss:string;
     pac,oook,last,counter,ldo:longint;
     outdata,indata,tempdata,indata2:text;
     lname,name2,winorloss:string;
     oldname,newname:string;

  label
      longname;

  begin
    restorecrtmode;    last := 1; ldo := 0; ok:='';  oook:= 0;
    longname:
    clrscr;
    writeln('Enter your code name:');
    readln(codename);

    if length(codename) > 25 then
      begin
        writeln('Code name to long, enter a new one.');
        delay(5000);
        goto longname;
      end;

    assign(indata,'filename.ply');
    reset(indata);
    repeat
      readln(indata,lname);
      readln(indata);
      readln(indata);
      if lname = codename then
         begin
           writeln('Codename already used.  Please enter a new one.');
           ldo := 1;
           delay(5000);
         end;
    until EOF(indata);
    close(indata);

    if (codename = 'Otto the Viking') or (codename = 'Ultimate') or
       (codename = 'Player 1') or (codename = 'Player 2') or
       (codename = 'Wimpy') or (codename = 'Allstar') or
       (codename = 'Cornholio') then
       begin
         ldo := 1;
         writeln('Codename already used.  Please enter a new one.');
         delay(5000);
       end;

    if ldo = 1 then
      begin
        ldo := 0;
        goto longname;
      end;

    writeln;
    writeln('Enter your personal password.');

    password:=getpassword(1,5);
    names[player] := codename;
{put in here}
    assign(indata,'fileptr.dat');
    reset(indata);
    readln(indata,oook);
    close(indata);
    str(oook,ok);
    filename := 'ply' + ok;
    assign(indata,'fileptr.dat');
    rewrite(indata);
    writeln(indata,oook+1);
    close(indata);

    filename := filename +'.pac';
    assign(outdata,filename);
    rewrite(outdata);
    writeln(outdata,codename);    {name}
    writeln(outdata,password);
    writeln(outdata,0);    {wins}
    writeln(outdata,0);    {losses}
    for counter :=1 to 5 do       {save to file and change ply file}
        writeln(outdata,stat[counter,player]);   {stats   1-100}
    writeln(outdata,left);
    writeln(outdata,0);
    writeln(outdata,0);
    close(outdata);
    encrypt(filename);
    assign(tempdata,'filename.ply');
    append(tempdata);
    writeln(tempdata,codename);
    writeln(tempdata,filename);
    writeln(tempdata,'0/0');
    close(tempdata);
    setgraphmode(vgahi);
  end;
{**************************************************************************}
procedure chgstuff;
              {changes attribs}
  type
      numarray2 = array[1..5,1..2] of longint;
  var
     left,empty,player,x1,y1,x2,y2,choice:longint;
     yorn, InputChar : char;
     nums : numarray2;
     stt:string;

  label
     escape;

  begin    {procedure}
    settextjustify(lefttext,toptext);
    settextstyle(DefaultFont,Horizdir,1);
    for y1 := 1 to 5 do
      begin
        nums[y1,1] := 46 + 40 * y1;   {set up varibales}
        nums[y1,2] := 59 + 40 * y1;
      end;

    player := 1;
    cleardevice;
    setcolor(blue);
    rectangle(199,205,466,300);
    setcolor(white);
    outtextxy(210,225,'Change player one''s attributes');
    outtextxy(210,270,'Change player two''s attributes');

    x1:= 205;   x2:=450;   y1:=220;         y2:=240;
    repeat

     if keypressed then
         InputChar := readkey
     else
         InputChar := ' ';

     if InputChar = #27 then
        goto escape
     else if InputChar=#0 then    {gets key and draws screen}
        begin
          InputChar := ReadKey;
          case InputChar of     {changes turret}
              'H':begin    {up}
                   if player = 2 then
                     begin
                        setcolor(black);
                        rectangle(x1,y1,x2,y2);
                        player :=  1;  y1:= 220;    y2:= 240;
                     end
                   else
                     begin
                        setcolor(black);
                        rectangle(x1,y1,x2,y2);
                        player := 2;   y1 := 265;     y2 :=285;
                     end;
                  end;
              'P':begin   {down}
                    if player = 2 then
                     begin
                        setcolor(black);
                        rectangle(x1,y1,x2,y2);
                        player :=  1;  y1:= 220;    y2:= 240;
                     end
                   else
                     begin
                        setcolor(black);
                        rectangle(x1,y1,x2,y2);
                        player := 2;   y1 := 265;     y2 :=285;
                     end;
                  end;
          end;
        end;

    setcolor(red);
    rectangle(x1,y1,x2,y2);
    until InputChar = #13;

    cleardevice;
    setcolor(blue);
    rectangle(150,75,490,310);
    setcolor(white);   setfillstyle(solidfill,red);
    rectangle(369,85,471,100);   outtextxy(175,90,'Extra Hit Points');
    rectangle(369,125,471,140);  outtextxy(175,130,'Acceleration');
    rectangle(369,165,471,180);  outtextxy(175,170,'Top speed');
    rectangle(369,205,471,220);  outtextxy(175,210,'Armor Strength');
    rectangle(369,245,471,260);  outtextxy(175,250,'Shot Power');
    outtextxy(285,288,'Quit');
    choice := 1;     x1 := 160;  y1:= 80; x2 := 475;   y2 := 105;
    empty:= stat[choice,player];
    setcolor(green);
    if player = 1 then
     begin
       outtextxy(220,50,'Player one''s attributes');
       names[1] := 'Player 1';
     end;
    if player = 2 then
      begin
        outtextxy(220,50,'Player two''s attributes');
        names[2] := 'Player 2';
      end;
    {more drawing}
    for left := 1 to 5 do
        stat[left,player] := 0;
    setcolor(white);
    rectangle(124,350,526,365);
    left := 400;
    bar(125,351,525,364);
    repeat
     if keypressed then
         InputChar := readkey
     else
         InputChar := ' ';
     if InputChar = #27 then
        goto escape
     else If InputChar=#0 then
        begin
        InputChar := ReadKey;
        case InputChar of
        'M':if (choice <> 6) and (left > 4) and (stat[choice,player]<96) then
             begin
              setfillstyle(solidfill,black);
              bar(370,nums[choice,1],370+empty,nums[choice,2]);
              bar(125,351,125+left,364);
              stat[choice,player] := stat[choice,player] + 5;
              empty := stat[choice,player];
              setfillstyle(solidfill,red);
              bar(369,nums[choice,1],370+empty,nums[choice,2]);
              left := left-5;
              bar(125,351,125+left,364);
             end;

        'K':if (choice <> 6) and (stat[choice,player]>4) then
             begin
              setfillstyle(solidfill,black);
              bar(370,nums[choice,1],370+empty,nums[choice,2]);
              bar(125,351,125+left,364);
              stat[choice,player] := stat[choice,player] - 5;
              empty := stat[choice,player];
              setfillstyle(solidfill,red);
              bar(369,nums[choice,1],370+empty,nums[choice,2]);
              left := left+5;
              bar(125,351,125+left,364);

             end;

        'H':begin                {up}
                 setcolor(black);
                 rectangle(x1,y1,x2,y2);
                 y1 := y1 - 40;      y2 := y2 - 40; choice := choice -1;
                 empty:=stat[choice,player];
               end;

           'P':begin     {down}
                 setcolor(black);
                 rectangle(x1,y1,x2,y2);
                 y1 := y1 +40;      y2 := y2 + 40;   choice := choice +1;
                 empty:=stat[choice,player];
               end;
        end;   {case}
     end    {if}

    else
        case InputChar of
             #13:if choice = 6 then choice := 7;
        end;

    if y1 < 75 then
       begin
         y1 := 280;   y2 := 305; choice := 6;
       end;

    if y1 > 305 then
       begin
         y1 := 80;  y2 := 105;  choice := 1;
       end;

    setcolor(red);
    rectangle(x1,y1,x2,y2);
    until choice = 7;
    sound(1000);delay(100);sound(2000);delay(100);nosound;
    setcolor(white);
    outtextxy(150,400,'Do you want to save these stats?  (Y or N)');
    yorn:=' ';
    repeat
          if keypressed then yorn:=upcase(readkey);
    until (yorn='Y') or (yorn='N');
    if yorn = 'Y' then newrecord(player,left);
    escape:
  end;     {procedure}

{**************************************************************************}
procedure loadrecord(files:filesarray;   choice:longint);

  var     {loads record}
     indata:text;
     playfile,counter:longint;
     letter1,password,realpassword:string;

label mistake;

  begin
     restorecrtmode;
     mistake:
     clrscr;
  if (files[choice,1] = names[1]) or (files[choice,1] = names[2]) then
     begin
        writeln('That file is already loaded.');
        delay(5000);
        setgraphmode(vgahi);
     end
  else
   begin
     writeln('As Player 1 or Player 2  (1 or 2)');
     readln(letter1);
     if letter1 = '1' then playfile := 1
     else if letter1 = '2' then playfile := 2
     else
       begin
         writeln('Invalid Choice!   Please Try Again.');
         delay(5000);
         goto mistake;
       end;
     if ((compplay=1) and (letter1='1')) or
                                   ((compplay=2) and (letter1='2')) then
       begin
         writeln('Sorry, you cannot change the computer player!');
         delay(5000);
         goto mistake;
         end;

     unencrypt(files[choice,2]);
     assign(indata,files[choice,2]);
     reset(indata);
     readln(indata);    {loads record}
     readln(indata,realpassword);
     readln(indata);
     readln(indata);
     writeln;
     writeln('Enter your personal password.');
     password := getpassword(1,5);
  if password = realpassword then
   begin
     for counter := 1 to 5 do
         readln(indata,stat[counter,playfile]);
     close(indata);
     encrypt(files[choice,2]);
     case choice of
       1:names[playfile] := files[choice,1];
       2:names[playfile] := files[choice,1];
       3:names[playfile] := files[choice,1];
       4:names[playfile] := files[choice,1];
     end;   {case}
   end
   else
    begin
      writeln;
      writeln('Incorrect password.');
      encrypt(files[choice,2]);
      delay(5000);
    end;
     setgraphmode(vgahi);
  end;
  end;   {procedure}
{**************************************************************************}
{**************************************************************************}
procedure delrecord(files:filesarray;  choice:longint;
   last:longint);
    {deletes record}
   var
     password,realpassword,in1,in2,in3:string;
     indata,outdata:text;
     yorn:char;

   begin
  if last <> 4 then
    begin
      restorecrtmode;
      writeln('Enter your personal password.');
      password := getpassword(1,2);
      unencrypt(files[choice,2]);
      assign(indata,files[choice,2]);
      reset(indata);
      readln(indata);
      readln(indata,realpassword);
      close(indata);
      if password = realpassword then
         begin
           writeln;
           writeln('Are you sure?  (Y/N)');
           readln(yorn);
           writeln;
           yorn:= upcase(yorn);
           if yorn = 'Y' then
              begin
                assign(outdata,files[choice,2]);
                erase(outdata);
                assign(outdata,'filename.tmp');
                rewrite(outdata);
                assign(indata,'filename.ply');
                reset(indata);
                repeat
                  readln(indata,in1);
                  readln(indata,in2);
                  readln(indata,in3);
                  if in1 <> files[choice,1] then
                     begin
                       writeln(outdata,in1);
                       writeln(outdata,in2);
                       writeln(outdata,in3);
                     end;
                until EOF(indata);
                close(indata);
                close(outdata);
                erase(indata);
                rename(outdata,'filename.ply');
              end    {yorn case}
            else
               encrypt(files[choice,2]);
         end
      else
         begin
           writeln;
           writeln('Incorrect Password.');
           encrypt(files[choice,2]);
           delay(20000);
         end;
  end
  else
      begin
        cleardevice;
        settextstyle(TriplexFont,HorizDir,3);
        setcolor(white);
        outtextxy(100,240,'Cannot delete, only four player files left!');
        repeat until keypressed;
        dummy:=readkey;
      end;
  setgraphmode(vgahi);
  loaddef;
  end;
{**************************************************************************}
{************************************************************************}
procedure seeatt;
   {so you can view the attributes}
   var
      rate,counter:longint;
      rating,win,loss,shots,hits,percent:string;

   begin
    view[10] := 0;
    rate:=0;
    rating :='0';
    if view[9] <> 0 then
        view[10] := trunc((view[8]/view[9])*100);

    cleardevice;     {set up the background}
    setcolor(blue);
    rectangle(150,75,490,270);
    setcolor(white);   setfillstyle(solidfill,red);
    rectangle(369,85,471,100);   outtextxy(175,90,'Extra Hit Points');
    rectangle(369,125,471,140);  outtextxy(175,130,'Acceleration');
    rectangle(369,165,471,180);  outtextxy(175,170,'Top speed');
    rectangle(369,205,471,220);  outtextxy(175,210,'Armor Strength');
    rectangle(369,245,471,260);  outtextxy(175,250,'Shot Power');
    setcolor(red);
    setfillstyle(solidfill,red);
    for counter := 1 to 5 do
        begin                {fill in the attrib}
          if (view[counter] <> 0) and (view[counter] <> 1)
                 and (view[counter] < 101) then
            begin
              rectangle(370,46+40*counter,369+view[counter],59+40*counter);
              floodfill(371,50+40*counter,red);
            end
          else if view[counter] = 1 then
           rectangle(370,46+40*counter,369+view[counter],59+40*counter)
          else if view[counter] > 100 then
           begin
             rectangle(370,46+40*counter,469,59+40*counter);
             floodfill(371,50+40*counter,red);
           end
        end;

   str(view[6],win);   str(view[7],loss);   str(view[8],hits);

   if view[9] <> 0 then
     begin
      str(view[8],hits);
      str(view[9],shots);
      str(view[10],percent);
     end;

   setcolor(green);
   outtextxy(150,300,'Wins: '+win);
   outtextxy(320,300,'Losses: '+loss);

   if view[9] = 0 then
    begin
      shots := '0';
      hits := '0';
      percent := '0';

    end;

   rate := view[6] * 20 - view[7] * 10 + trunc(view[10]/4);

   str(rate,rating);

   outtextxy(150,330,'Shots: '+shots);
   outtextxy(320,330,'Hits: '+hits);
   outtextxy(150,360,'Hit %: '+percent);
   outtextxy(320,360,'Pac-Tank Rating: '+rating);
   repeat
   until keypressed;
   end;
{**************************************************************************}
{**************************************************************************}
procedure viewrecord(files:filesarray; choice:integer);   {to view records}
  var
    redata:text;
    counter:longint;

  begin
    unencrypt(files[choice,2]);
    assign(redata,files[choice,2]);
    reset(redata);   {get the info}
    readln(redata);
    readln(redata);
    readln(redata,view[6]);
    readln(redata,view[7]);
    for counter := 1 to 5 do
        readln(redata,view[counter]);
    readln(redata);
    readln(redata,view[8]);
    readln(redata,view[9]);
    close(redata);
    encrypt(files[choice,2]);
    seeatt;
  end;    {procedure}
{************************************************************************}
function caps(var word:string): string;
 var
    counter:longint;
    newword:string;

 begin
   newword := '';
   for counter := 1 to length(word) do
       newword := newword + upcase(word[counter]);

   caps := newword;
 end;
{************************************************************************}
{**************************************************************************}
procedure findstats;

  var
    indata:text;
    wins,losses,shot,hit,per,counter2,counter,contest,rate:longint;
    winner,loser,percent,file3,name1,winloss,rating,good:string;

  begin
  for counter := 1 to 2 do
   begin
    file3 := '-99';
    if names[counter] = 'Cornholio' then file3 := 'corn.pac';
    if names[counter] = 'Allstar' then file3 := 'star.pac';
    if names[counter] = 'Wimpy' then file3 := 'wimpy.pac';
    if names[counter] = 'Player 1' then file3 := 'player1.pac';
    if names[counter] = 'Player 2' then file3 := 'player2.pac';
    if names[counter] = 'Ultimate' then file3 := 'ult.pac';
    if names[counter] = 'Otto the Viking' then file3 := 'otto.pac';

    if file3 = '-99' then
     begin
        assign(indata,'filename.ply');
         reset(indata);

        repeat
         readln(indata,name1);
         if names[counter] = name1 then
           begin
            readln(indata,file3);
            readln(indata,winloss);
          end
         else
          begin
            readln(indata);
            readln(indata);
          end;
        until eof(indata);
        close(indata);
     end;    {file := -99}

     unencrypt(file3);

     assign(indata,file3);
     reset(indata);

     for contest :=1 to 2 do
        readln(indata);

     readln(indata,wins);
     readln(indata,losses);

     for contest :=1 to 6 do
        readln(indata);

     readln(indata,hit);
     readln(indata,shot);

     str(wins,winner);
     str(losses,loser);
     winloss := winner+'/'+loser;
     showstat[1,counter] := winloss;

     showstat[2,counter] := rating;
     if shot = 0 then per := 0
     else per := trunc((hit /shot) * 100);

     str(per,percent);
     showstat[2,counter] := percent;

     rate := wins * 20 - losses * 10 + trunc(per/4);
     str(rate,good);
     showstat[3,counter] := good;
     close(indata);
     encrypt(file3);
  end;   {counter loop}
end;    {end o'pro}
{**************************************************************************}
procedure resetroster;
 var
   erdata,outdata:text;
   dummy:integer;

 begin
   {$I-}
   assign(erdata,'*.pac');
   erase(erdata);
   {$I+}
   dummy:=IOResult;

   assign(outdata,'fileptr.dat');
   rewrite(outdata);
   writeln(outdata,'0');
   close(outdata);

   assign(outdata,'filename.ply');
   rewrite(outdata);
   writeln(outdata,'Speedy');
   writeln(outdata,'Speedy.pac');
   writeln(outdata,'0/0');
   writeln(outdata,'Tanker');
   writeln(outdata,'Tanker.pac');
   writeln(outdata,'0/0');
   writeln(outdata,'Floppy');
   writeln(outdata,'Floppy.pac');
   writeln(outdata,'0/0');
   writeln(outdata,'Cobra');
   writeln(outdata,'cobra.pac');
   writeln(outdata,'0/0');
   close(outdata);

   assign(outdata,'speedy.pac');
   rewrite(outdata);
   writeln(outdata,'Speedy');
   writeln(outdata,'Speedy');
   writeln(outdata,'0');
   writeln(outdata,'0');
   writeln(outdata,'0');
   writeln(outdata,'100');
   writeln(outdata,'100');
   writeln(outdata,'0');
   writeln(outdata,'0');
   writeln(outdata,'0');
   writeln(outdata,'0');
   writeln(outdata,'0');
   close(outdata);

   assign(outdata,'tanker.pac');
   rewrite(outdata);
   writeln(outdata,'Tanker');
   writeln(outdata,'Tanker');
   writeln(outdata,'0');
   writeln(outdata,'0');
   writeln(outdata,'100');
   writeln(outdata,'0');
   writeln(outdata,'0');
   writeln(outdata,'100');
   writeln(outdata,'100');
   writeln(outdata,'0');
   writeln(outdata,'0');
   writeln(outdata,'0');
   close(outdata);

   assign(outdata,'floppy.pac');
  rewrite(outdata);
  writeln(outdata,'Floppy');
  writeln(outdata,'Floppy');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'50');
  writeln(outdata,'50');
  writeln(outdata,'50');
  writeln(outdata,'50');
  writeln(outdata,'50');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  close(outdata);


  assign(outdata,'cobra.pac');
  rewrite(outdata);
  writeln(outdata,'Cobra');
  writeln(outdata,'Cobra');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'75');
  writeln(outdata,'75');
  writeln(outdata,'75');
  writeln(outdata,'75');
  writeln(outdata,'75');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  close(outdata);

  assign(outdata,'corn.pac');
  rewrite(outdata);
  writeln(outdata,'Cornholio');
  writeln(outdata,'Cornholio');
  writeln(outdata,'40');
  writeln(outdata,'1');
  writeln(outdata,'200');
  writeln(outdata,'200');
  writeln(outdata,'200');
  writeln(outdata,'200');
  writeln(outdata,'200');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  close(outdata);

  assign(outdata,'star.pac');
  rewrite(outdata);
  writeln(outdata,'Allstar');
  writeln(outdata,'Allstar');
  writeln(outdata,'25');
  writeln(outdata,'7');
  writeln(outdata,'100');
  writeln(outdata,'100');
  writeln(outdata,'100');
  writeln(outdata,'100');
  writeln(outdata,'100');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  close(outdata);

  assign(outdata,'wimpy.pac');
  rewrite(outdata);
  writeln(outdata,'Wimpy');
  writeln(outdata,'Wimpy');
  writeln(outdata,'5');
  writeln(outdata,'19');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  close(outdata);

  assign(outdata,'player1.pac');
  rewrite(outdata);
  writeln(outdata,'Player 1');
  writeln(outdata,'Player 1');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  close(outdata);

  assign(outdata,'player2.pac');
  rewrite(outdata);
  writeln(outdata,'Player 2');
  writeln(outdata,'Player 2');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  close(outdata);

  assign(outdata,'ult.pac');
  rewrite(outdata);
  writeln(outdata,'Ultimate');
  writeln(outdata,'Ultimate');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  close(outdata);

  assign(outdata,'otto.pac');
  rewrite(outdata);
  writeln(outdata,'Otto the Viking');
  writeln(outdata,'Otto the Viking');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  writeln(outdata,'0');
  close(outdata);

  encrypt('speedy.pac');
  encrypt('tanker.pac');
  encrypt('floppy.pac');
  encrypt('cobra.pac');
  encrypt('corn.pac');
  encrypt('wimpy.pac');
  encrypt('star.pac');
  encrypt('player1.pac');
  encrypt('player2.pac');
  encrypt('ult.pac');
  encrypt('otto.pac');
 end;