{$M 32768,0,655360}
program PacTank;

uses
    CRT,Graph;

const
    version = '3.11';
    minecount = 5;                           {maximum number of mines}
    bulletcount = 20;
    tanksize = 8;

type
    filesarray = array[1..4,1..3] of string;
    letterarray = array[1..2,1..62] of char;

var
   {global variables}
   names:array[1..2] of string;
   damage:array[1..2] of real;
   view:array[1..10] of longint;   {wins,losses,hits,shots,%}
   hits:array[1..4,1..3] of longint;  {player,position}
   mine:array[1..2,1..minecount] of record    {mine positions}
            x,y:integer;
            gone:boolean;
            end;
   invismine,bullfx:boolean;          {flags for invisible mines, bullet snds}
   showstat:array[1..3,1..2] of string;{some show stats thing}
   turret : array[1..2,1..6] of longint;{turret pos, angle}
   stat:array[1..5,1..2] of longint;  {stores more stats}
   attrib:array[1..4,1..2] of real;   {stores attribs}
   bullet:array[1..2,1..bulletcount] of record {bullet positions}
                  x1,y1,x2,y2,dir:integer;
                  used:boolean;
                  end;
   ErrorFlag:boolean;                 {checks for IO errors}
   dummy:char;
   angleinc:array[1..2] of integer; {current turning speed}

   {for main program}
   Option,Count,compplay:integer;
   plr1,plr2:string;

{$I pac2nd.pas}

{**************************************************************************}
procedure humanplayer(where:integer);
  var
   indata:text;
   error:integer;
   rate,hit,shot,per,win,loss,other,who,counter:integer;
   namer,winner,losser,filen:string;

  begin
    if where = 1 then other :=2
    else other :=1;
    assign(indata,'filename.ply');
    reset(indata);

    readln(indata,namer);
    if namer <> names[other] then readln(indata,filen)
    else
      begin
        readln(indata);
        readln(indata);
        readln(indata,names[where]);
        readln(indata,filen);
      end;
    close(indata);
    unencrypt(filen);
    assign(indata,filen);
    reset(indata);
    readln(indata,names[where]);
    readln(indata);
    readln(indata,win);
    readln(indata,loss);
    for counter := 1 to 5 do
      readln(indata,stat[counter,where]);
    readln(indata);
    readln(indata,hit);
    readln(indata,shot);
    close(indata);
    encrypt(filen);
    str(win,winner);
    str(loss,losser);
    showstat[1,where] := winner+'/'+losser;
    if shot = 0 then per := 0
    else per := trunc((hit/shot)*100);
    str(per,showstat[2,where]);
    rate := win * 20 - loss * 10 + trunc(per/4);
    str(rate,showstat[3,where]);
  end;

{**************************************************************************}

procedure compplayer(where:integer);
  var
   indata:text;
   error:integer;
   rate,hit,shot,per,win,loss,other,who,counter:integer;
   winner,losser,filen:string;

  begin
    if where = 1 then other :=2
    else other :=1;

    val(showstat[3,other],who,error);

    if who > 300 then filen := 'corn.pac'
    else if who > 150 then filen := 'star.pac'
    else filen := 'wimpy.pac';

    unencrypt(filen);
    assign(indata,filen);
    reset(indata);
    readln(indata,names[where]);
    readln(indata);
    readln(indata,win);
    readln(indata,loss);
    for counter := 1 to 5 do
      readln(indata,stat[counter,where]);
    readln(indata);
    readln(indata,hit);
    readln(indata,shot);
    close(indata);
    encrypt(filen);
    str(win,winner);
    str(loss,losser);
    showstat[1,where] := winner+'/'+losser;
    if shot = 0 then per := 0
    else per := trunc((hit/shot)*100);
    str(per,showstat[2,where]);
    rate := win * 20 - loss * 10 + trunc(per/4);
    str(rate,showstat[3,where]);
  end;

{**************************************************************************}
procedure switch;

  type
    ball = array[1..5] of integer;
    ball2 = array[1..3] of string;

  var
    all:ball;
    all2:ball2;
    namechange:string;
    counter:integer;

  begin
    for counter := 1 to 5 do
      begin
        all[counter] := stat[counter,1];
        stat[counter,1] := stat[counter,2];
        stat[counter,2] := all[counter]
      end;

  namechange := names[1];  names[1] := names[2];  names[2] := namechange;

  for counter := 1 to 3 do
      begin
        all2[counter] := showstat[counter,1];
        showstat[counter,1] := showstat[counter,2];
        showstat[counter,2] := all2[counter]
      end;

  end;


{**************************************************************************}
procedure minecheck(var statchng:boolean;
                     var won:integer);

  var              {moves bullets}
     count1,count2:integer;
     distx1,disty1,sqrd1,distx2,disty2,sqrd2:longint;

  begin  {procedure}
    for count1:=1 to 2 do
        for count2:=1 to minecount do
            if not mine[count1,count2].gone then
               with mine[count1,count2] do
                    begin
                    distx1:=turret[1,1]-x;
                    disty1:=turret[1,2]-y;
                    distx2:=turret[2,1]-x;
                    disty2:=turret[2,2]-y;
                    sqrd1:=abs(sqr(distx1))+abs(sqr(disty1));
                    sqrd2:=abs(sqr(distx2))+abs(sqr(disty2));
                    if sqrt(sqrd1)<=(tanksize+4) then
                       begin
                       gone :=True;
                       damage[1]:=damage[1]-30;
                       sound(2094);delay(20);nosound;
                       statchng:=true;
                       if not invismine then
                          begin
                          setfillstyle(solidfill,red);
                          bar(x-7,y-7,x+7,y+7);
                          sound(1000);delay(200);nosound;
                          setfillstyle(solidfill,green);
                          bar(x-7,y-7,x+7,y+7);
                          end;
                       end
                    else if sqrt(sqrd2)<=(tanksize+4) then
                       begin
                       gone :=True;
                       damage[2]:=damage[2]-30;
                       sound(1567);delay(20);nosound;
                       statchng:=true;
                       if not invismine then
                          begin
                          setfillstyle(solidfill,red);
                          bar(x-7,y-7,x+7,y+7);
                          sound(2000);delay(200);nosound;
                          setfillstyle(solidfill,green);
                          bar(x-7,y-7,x+7,y+7);
                          end;
                       end; {if sqrt<12}
                    end; {with}
    if damage[1] < 0 then
        won := 2
    else if damage[2] < 0 then
        won := 1
    else
        won := 0;
 end;   {procedure}

{**************************************************************************}
procedure minestart(player:integer);
 var
    color1,color2,angle,count:integer;         {starts off the bullets}
    already:boolean;

 begin
    already:=false;
    for count:=1 to minecount do
       if (mine[player,count].x = 0) and (not already) then
         with mine[player,count] do
              begin
              angle := turret[player,5];
              x :=ROUND(-13 * SIN(angle * PI / 180) + turret[player,1]);
              y :=ROUND(-13 * COS(angle * PI / 180) + turret[player,2]);
              if not invismine then
                 begin
                 setcolor(4);
                 setfillstyle(SolidFill,14);
                 circle(x,y,4);
                 floodfill(x,y,4);
                 end;
              gone:=False;
              already:=True;
              end; {with}
 end;   {procedure}

{**************************************************************************}
procedure UpdateStats(winner:integer);  {saves to files}
  type
      suckarray = array[1..5] of integer;
  var
     indata,outdata:text;
     password,pass,pass1,pass2,coden,filen,newval,winlosss:string;
     andrew,lefts,addon,times,wins,losses,shot,hitss,counter2,counter,
     seccounter:longint;
     useless :suckarray;

  begin
   addon := 0;  shot :=0;  hitss:= 0;
   for counter := 1 to 2 do   {winner and loser}
   begin
    newval := ' ';

    if names[winner] = 'Cornholio' then filen := 'corn.pac'
    else if names[winner] = 'Allstar' then filen := 'star.pac'
    else if names[winner] = 'Wimpy' then filen := 'wimpy.pac'
    else if names[winner] = 'Player 1' then filen := 'player1.pac'
    else if names[winner] = 'Player 2' then filen := 'player2.pac'
    else if names[winner] = 'Ultimate' then filen := 'ult.pac'
    else if names[winner] = 'Otto the Viking' then filen := 'otto.pac'
    else
     begin
    times := 0;
     assign(indata,'filename.ply');  {finds the file}
     reset(indata);
    repeat
      readln(indata,coden);    {gets the pac file name}
      readln(indata,filen);
      readln(indata,winlosss);
      if coden = names[winner] then times := 1;
    until (coden = names[winner]) and (times = 1);

    close(indata);
     end;

    unencrypt(filen);
    assign(indata,filen);
    reset(indata);
    readln(indata,coden);
    readln(indata,password);
    readln(indata,wins);
    readln(indata,losses);     {reads in the players information}
    for seccounter := 1 to 5 do
        readln(indata,useless[seccounter]);
    close(indata);

    case counter  of
         1:begin
                   wins := wins +1;   {changes wins and attribs}
                   addon:=10;
                  end;
         2:begin
                   losses := losses+1;  {changes losses}
                   addon := 0;
                 end;
    end;

    str(wins,pass);  str(losses,pass1);  newval := pass + '/' + pass1;
    assign(indata,filen);
    reset(indata);
    for counter2 := 1 to 9 do
     readln(indata);

    readln(indata,lefts);
    readln(indata,hitss);
    readln(indata,shot);
    close(indata);
    assign(outdata,filen);   {saves to the pac file}
    rewrite(outdata);
    writeln(outdata,coden);
    writeln(outdata,password);
    writeln(outdata,wins);
    writeln(outdata,losses);
    for seccounter := 1 to 5 do
      if useless[seccounter] < 150 then
          writeln(outdata,useless[seccounter])
      else
        writeln(outdata,useless[seccounter]);

    if lefts+addon > 391 then
        writeln(outdata,'400')
    else
        writeln(outdata,lefts+addon);

    writeln(outdata,hits[winner,1]+hitss);
    writeln(outdata,hits[winner,2]+shot);

    close(outdata);
    encrypt(filen);

    assign(outdata,'filename.tmp');    {change the ply file}
    rewrite(outdata);
    assign(indata,'filename.ply');
    reset(indata);
    repeat
      readln(indata,pass);
      readln(indata,pass1);
      readln(indata,pass2);
      if pass <> names[winner] then
         begin
           writeln(outdata,pass);
           writeln(outdata,pass1);
           writeln(outdata,pass2);
         end
      else
         begin
           writeln(outdata,pass);
           writeln(outdata,pass1);
           writeln(outdata,newval);
         end;
    until EOF(indata);
    close(indata);    close(outdata);
    erase(indata);
    rename(outdata,'filename.ply');
    case winner of
      1:winner := 2;
      2:winner := 1;
    end;

   end;      {big if}
 end;   {procedure}

{**************************************************************************}
procedure bulletstart(player:integer);
 var
    firstfound,count:integer;         {starts off the bullets}

 begin
   count := 0;   firstfound := 0;

   repeat
      count := count+1;
      if not bullet[player,count].used then
         firstfound := count;
   until (firstfound <> 0) or (count=bulletcount);
   if firstfound <> 0 then
     with bullet[player,firstfound] do
      begin
      hits[player,2] := hits[player,2] +1;
      setcolor(red);
      x1 := turret[player,3];      {find co-ord and draw 1st time}
      y1 := turret[player,4];
      dir := turret[player,5];
      x2 :=ROUND(4 * SIN(dir * PI / 180) + x1);
      y2 :=ROUND(4 * COS(dir * PI / 180) + y1);
      used := True;
      line(x1,y1,x2,y2);
      end;
 end;   {procedure}

{**************************************************************************}
procedure ai( player:integer);
  var
    xdist,ydist,zdist,otherp,angle:longint;
    hypo,toa:real;
    shoot:boolean;
    angle1:string;

  begin
    {turret 1,1 = x1   turret 1,2 = y1  turret 1,3 = x2  turret 1,4 = y2
     turret 1,5 = degrees of turret  turret 1,6 = speed}

    xdist := 0;  ydist :=0;  otherp := 0;  zdist :=0;  shoot := false;

    if player = 1 then otherp := 2
    else if player =2 then otherp := 1;

    xdist := turret[player,1] - turret[otherp,1];
    ydist := turret[player,2] - turret[otherp,2];

    hypo := round(sqrt(sqr(xdist) + sqr(ydist)));

    if ydist <> 0 then toa := xdist/ydist
    else toa := 0;

    angle := round(arctan(toa)/(PI/180));

    if (xdist > 0) and (ydist < 0) then    {bottom left}
       angle := angle + 360
    else if (xdist > 0) and (ydist > 0) then   {top left}
       angle := abs(angle) + 180
    else if (xdist < 0) and (ydist > 0) then   {top right   change}
       angle := angle + 180;

    if (xdist = 0) and (ydist > 0) then angle := 180
    else if (xdist = 0) and (ydist < 0) then angle := 0;

    turret[player,5] := angle;

    if hypo > 170 then

      begin
     if turret[player,6] < 18-round(attrib[3,player]) then
      turret[player,6] := turret[player,6] + round(attrib[3,player])
      else
        turret[player,6] := 18
      end

    else if (hypo < 170) and (hypo > 100) then
      begin
        turret[player,6] := turret[player,6] - round(attrib[3,player]);
        bulletstart(player);
      end
    else if (hypo < 100) and (hypo > 50) then
      begin
        turret[player,6] := 0;
        bulletstart(player);
        shoot := true;
      end
    else if hypo < 50 then
      begin
       turret[player,6] := turret[player,6] - round(attrib[3,player]);
       bulletstart(player);
       shoot := true;
      end;

  end;
{**************************************************************************}

{**************************************************************************}
procedure RegisterHit(Player:integer; var won:integer);
                      {duh}  {shows if you're hit}
begin
     won := 0;
     if player= 1 then
       begin
        damage[1]:=damage[1]-attrib[4,1];    {take damage}
        hits[2,1] := hits[2,1] +1;
       end
     else
       begin
        damage[2]:=damage[2]-attrib[4,2];
        hits[1,1] := hits[1,1] +1;
       end;
     if damage[1]<=0 then
        won:=2
     else if damage[2]<=0 then
        won:=1
     else
        won:=0;

     if won <> 0 then UpdateStats(won);

end;
{**************************************************************************}

{**************************************************************************}
procedure bulletmove(var statchng:boolean;
                     var won:integer);
  var              {moves bullets}
     count,counter:integer;
     distx1,distx2,disty1,disty2,sqrd1,sqrd2:longint;

  begin  {procedure}
     statchng:=False;
     for count :=1 to 2 do
      for counter := 1 to bulletcount do
         if bullet[count,counter].used then    {moves bullet}
            begin
             with bullet[count,counter] do
             begin   {with}
              setcolor(green);
              line(x1,y1,x2,y2);
              x1 := x1 + round(20*sin(dir*pi/180)) div 2;  {moves bullet}
              y1 := y1 + round(20*cos(dir*pi/180)) div 2;
              x2 :=ROUND(4 * SIN(dir * PI / 180) + x1);
              y2 :=ROUND(4 * COS(dir * PI / 180) + y1);
              if (x1 < 5) or (x1 > 635) or (y1 < 25) or (y1 > 475) then
                 used := false
             else
              begin
                distx1:=turret[1,1]-x1;
                distx2:=turret[2,1]-x1;
                disty1:=turret[1,2]-y1;
                disty2:=turret[2,2]-y1;
                sqrd1:=abs(sqr(distx1))+abs(sqr(disty1));
                sqrd2:=abs(sqr(distx2))+abs(sqr(disty2));
                if bullfx then
                   begin
                   if count=1 then
                      sound(round(sqrt(sqrd2))*4)
                   else
                      sound(round(sqrt(sqrd1))*4);
                   delay(10);
                   nosound;
                   end;
                if sqrt(sqrd1)<=tanksize then
                   begin
                   RegisterHit(1,won);
                   used:=false;
                   statchng:=true;
                   sound(500);delay(10);nosound;
                   end
                else if sqrt(sqrd2)<=tanksize then
                   begin
                   RegisterHit(2,won);
                   used:=false;
                   statchng:=true;
                   sound(1000);delay(10);nosound;
                   end
              else
                begin   {draw}
                  setcolor(red);
                  line(x1,y1,x2,y2);    {draws bullet}
                end;  {ELSE}
              end; {else}
            end;   {with}
            end;   {IF}
 end;   {procedure}
{**************************************************************************}

{**************************************************************************}
procedure StatusUpdate;    {the damage indicatior}
var
   Player1,Player2,Player1pts,Player2pts:string;

begin
     if invismine = true then
          begin
          setfillstyle(solidfill,white);
          setcolor(red);
          end
     else
          begin
          setfillstyle(solidfill,red);
          setcolor(white);
          end;
     bar(0,0,639,19);
     SetTextStyle(defaultfont,horizdir,1);
     settextjustify(lefttext,toptext);
     Str(damage[1]:3:0,Player1pts);
     Str(damage[2]:3:0,Player2pts);
     Player1:=names[1] + ' '+Player1pts;   {hit point indicator}
     Player2:=names[2] + ' '+Player2pts;
     OutTextXY(25,2,Player1);
     OutTextXY(320,2,Player2);
end;
{**************************************************************************}

{**************************************************************************}
procedure StartScreen;   {self explanitory}
var
   OldPalette:palettetype;
begin
     cleardevice;
     GetPalette(OldPalette);
     SetTextStyle(TriplexFont,HorizDir,10);   {Set text settings}
     SetTextJustify(CenterText,TopText);
     SetColor(1);
     OutTextXY(GetMaxX div 2,0,'PAC-TANK');
     SetTextStyle(TriplexFont,HorizDir,7);
     SetColor(2);
     OutTextXY(GetMaxX div 2,120,'The Final Assault');
     SetColor(3);
     SetTextStyle(TriplexFont,HorizDir,4);
     OutTextXY(GetMaxX div 2, 400,'Press Any Key to Continue!!');
     repeat
           SetPalette(1,Random(16));
           SetPalette(2,Random(16));
           SetPalette(3,Random(16));
           sound(random(50));
           delay(5);
           if Random<0.1 then
              SetPalette(0,Random(16));
     until KeyPressed;
     nosound;
     SetAllPalette(OldPalette);
end;
{**************************************************************************}

{**************************************************************************}
procedure MainMenu(var OptionChoice:integer;  plr1comp,plr2comp:string);
var    {ending sequence}         {just kidding, main menu}
   outdata,indata:text;
   Thick:longint;
   Dummy,Choice:char;
   d1,d2:string;

begin
     SetColor(white);
     SetTextStyle(TriplexFont,HorizDir,4);   {Set text settings}
     SetTextJustify(CenterText,TopText);
     SetBkColor(black);
     ClearDevice;                      {print out the menu on the screen}
     OutTextXY(GetMaxX div 2,20,'Pac-Tank: The Final Assault!');
     OutTextXY(GetMaxX div 2,50,'Main Menu');
     OutTextXY(GetMaxX div 2,80,'Press the letter of your choice:');
     SetTextJustify(LeftText,TopText);
     OutTextXY(50,160,'A: Play Game');
     OutTextXY(50,200,'B: Instructions');
     OutTextXY(50,240,'C: Change Tank Setup');
     OutTextXY(50,280,'D: Records');
     OutTextXY(50,320,'E: Quit');
     SetTextStyle(defaultfont,horizdir,1);
     SetTextJustify(centerText,Toptext);

     setcolor(lightblue);
     outtextxy(140,370,'Player 1: '+names[1]);
     outtextxy(140,380,plr1comp);
     outtextxy(140,390,'Win/Loss: '+showstat[1,1]);
     outtextxy(140,400,'Shot % : '+showstat[2,1]);
     outtextxy(140,410,'Pac-Tank Rating: '+showstat[3,1]);

     setcolor(green);
     outtextxy(430,370,'Player 2: '+names[2]);
     outtextxy(430,380,plr2comp);
     outtextxy(430,390,'Win/Loss: '+showstat[1,2]);
     outtextxy(430,400,'Shot % : '+showstat[2,2]);
     outtextxy(430,410,'Pac-Tank Rating: '+showstat[3,2]);

     setcolor(white);
     SetTextJustify(RightText,Toptext);
     OutTextxy(635,470,'V '+version);
     if KeyPressed then  {clear the keyboard buffer}
        Dummy:=ReadKey;
     SetFillStyle(SolidFill,0);
     SetTextJustify(CenterText,TopText);
     Choice:=' ';
     SetColor(White);
     repeat {until valid choice entered}
          SetColor(Random(GetMaxColor)+1); {set a random color}
          if Random>0.5 then   {randomly choose thick or thin}
            Thick:=1
          else
            Thick:=3;
          SetLineStyle(Random(5)-1,0,Thick); {set the randomly chosen}
          Rectangle(0,0,GetMaxX,GetMaxY); {width, draw border}
          delay(200);
          SetColor(0);
          SetLineStyle(SolidLn,0,ThickWidth); {clear it off}
          Rectangle(0,0,GetMaxX,GetMaxY);
          If KeyPressed then  {if they pressed a key, get it}
             begin
             Choice:=ReadKey;
             if (choice = #9) and (not invismine) then
               begin
                 setfillstyle(solidfill,black);
                 bar(10,420,630,440);
                 invismine:=true;
                 SetColor(white);
                 OutTextXY(320,430,'Invisible Mines Activated!!!');
                 sound(1500); delay(200); sound(2000); delay(200);
                 sound(2500); delay(200); nosound;
               end
             else if (choice = #9) and invismine then
               begin
                 setfillstyle(solidfill,black);
                 bar(10,420,630,440);
                 invismine:=false;
                 SetColor(white);
                 OutTextXY(320,430,'Invisible Mines Deactivated!!!');
                 sound(1500); delay(200); sound(2000); delay(200);
                 sound(2500); delay(200); nosound;
               end;
             if choice = #18 then
               begin
                setfillstyle(solidfill,black);
                bar(10,420,630,440);
                SetColor(white);
                OutTextXY(GetMaxx div 2,430,'Resetting Rosters!!!');
                resetroster;
                loaddef;
                findstats;
                Choice := '9';
                sound(1000); delay(200); sound(1500); delay(200);
                sound(2000); delay(200); nosound;
                delay(2000);
                bar(10,420,630,440);
              end;
             if (choice=#2) and (not bullfx) then
                begin
                setfillstyle(solidfill,black);
                bar(10,420,630,440);
                bullfx:=True;
                SetColor(white);
                OutTextXY(320,430,'Secret Bullet Sound Effects Activated!');
                sound(500); delay(200); sound(1000); delay(200);
                sound(1500); delay(200); nosound;
                end
             else if (choice=#2) and bullfx then
               begin
                setfillstyle(solidfill,black);
                bar(10,420,630,440);
                bullfx:=false;
                SetColor(white);
                OutTextXY(315,430,'Secret Bullet Sound Effects Deactivated!');
                sound(500); delay(200); sound(1000); delay(200);
                sound(1500); delay(200); nosound;
                end
             else
                Choice:=Upcase(Choice);
             end;
     until (Choice>='A') and (Choice<='E') or (Choice = '1') or (Choice = '2')
        or (Choice = '9') or (Choice=#21) or (Choice=#15);
     if choice=#21 then
        choice:='F'
     else if choice=#15 then
        choice:='G';
     sound(200);   {repeat until they enter}         {valid choice}
     delay(50);
     sound(100);
     delay(50);        {make the sound}
     nosound;
     SetLineStyle(SolidLn,0,NormWidth);
     OptionChoice:=Ord(Choice)-64;
end;
{**************************************************************************}

{**************************************************************************}
procedure SetupBoardPlrs;
var       {set vars to what they should be}
   count,count2:longint;

begin
   {turret 1,1 = x1   turret 1,2 = y1  turret 1,3 = x2  turret 1,4 = y2
   turret 1,5 = degrees of turret  turret 1,6 = speed}
   {hit points}

   for count :=1 to 2 do
     for count2 :=1 to minecount do
       begin
       mine[count,count2].x := 0;
       mine[count,count2].y := 0;
       mine[count,count2].gone :=True;
       end;

   turret[1,1] := 100; turret[1,2] := 100;  turret[1,3] := 100;
   turret[1,4] := 108; turret[1,5] := 90;   turret[1,6] := 1;

   turret[2,1] := 540; turret[2,2] := 380;  turret[2,3] := 540;
   turret[2,4] := 388; turret[2,5] := 270;   turret[2,6] := 1;

   setcolor(white);
   rectangle(0,20,639,479);
   setbkcolor(green);
   for count := 1 to 2 do
       for count2 := 1 to bulletcount do
           with bullet[count,count2] do
              begin
                x1:=0;  y1:= 0;   x2 := 0;   y2 := 0;
                dir := 0;   used := false;
end;
end;
{**************************************************************************}

{**************************************************************************}
procedure KeyMove(var quit:boolean;
                  var won:integer;
                  player:integer);

var                  {gets the key pressed}
   InputChar:char;

begin
     Quit:=False;
     if keypressed then
         InputChar := readkey
     else
         InputChar :=#255;
     If InputChar=#0 then
        begin
        InputChar := ReadKey;
        if (player <> 1) then
         begin
          case InputChar of     {changes turret}
             'H':turret[1,6] := turret[1,6] + round(attrib[2,1]);
             'M':if angleinc[1]<>-4 then angleinc[1]:=angleinc[1]-2;
             'P':turret[1,6] :=turret[1,6] -round(attrib[2,1]);
             'K':if angleinc[1]<>4 then angleinc[1]:=angleinc[1]+2;

          end;   {case}
         end;
        end {if}
     else
         case UpCase(InputChar) of
           'W':if player <> 2 then
                    turret[2,6] := turret[2,6] + round(attrib[2,2]);
           'D':if player <> 2 then
                  if angleinc[2]<>-4 then angleinc[2]:=angleinc[2]-2;
           'A':if player <> 2 then
                  if angleinc[2]<>4 then angleinc[2]:=angleinc[2]+2;
           'S':if player <> 2 then
                   turret[2,6] := turret[2,6] -round(attrib[2,2]);
           #27:begin
                    Quit:=True;
                    won:=0;
               end;
           #13:begin
                  if player <> 1 then
                     bulletstart(1);
               end;
           ' ':begin
                 if player <> 2 then
                   bulletstart(2);
               end;
           #43:begin
                 if player <> 1 then
                   minestart(1);
               end;
           'Z':begin
                 if player <> 2 then
                   minestart(2);
               end;
         end;
end;
{**************************************************************************}

{**************************************************************************}
procedure DrawTank(which,TankClr,TurretClr:longint);
begin    {destroys small european countries}     {jusk kidding}
     setcolor(turretclr);  {un-draw tank}
     line(turret[which,1],turret[which,2],turret[which,3],turret[which,4]);
     SetColor(tankclr);
     circle(turret[which,1],turret[which,2],TankSize);
end;
{**************************************************************************}

{**************************************************************************}
procedure ChkMovBounce(x:integer);
 var
    InputChar,Ex : char;    {bounce routine}

begin
     {make degrees 0-360 and changes speed}
     if turret[x,5] > 360 then turret[x,5] := turret[x,5]-360;
     if turret[x,5] < 0 then turret[x,5] :=turret[x,5]+360;
     if turret[x,6] > attrib[3,x] then  turret[x,6] := round(attrib[3,x]);
     if turret[x,6] < -5 then turret[x,6] := -5;
     if turret[x,1] < 15 + abs(turret[x,6]) + abs(tanksize-8) then     {left wall}
        begin
          turret[x,5]:=360-turret[x,5];
          turret[x,1] := 15 + abs(turret[x,6]);
          angleinc[x]:=0;
        end;

     if turret[x,1] > 625-abs(turret[x,6]) + abs(tanksize-8) then    {right wall}
        begin
          turret[x,5]:=360-turret[x,5];
          turret[x,1] := 625 - abs(turret[x,6]);
          angleinc[x]:=0;
        end;

     if turret[x,2] < 30 + abs(turret[x,6]) + abs(tanksize-8) then {top wall}
         if turret[x,5]<=180 then
          begin
           turret[x,5]:=180-turret[x,5];
           turret[x,2]:= 30 + abs(turret[x,6]);
           angleinc[x]:=0;
          end
         else
          begin
           turret[x,5]:=540-turret[x,5];
           turret[x,2]:= 30 + abs(turret[x,6]);
           angleinc[x]:=0;
          end;

     if turret[x,2] > 470-abs(turret[x,6]) + abs(tanksize-8) then   {bottom wall}
         if turret[x,5]<=180 then
          begin
           turret[x,5]:=180-turret[x,5];
           turret[x,2]:= 470 - abs(turret[x,6]);
           angleinc[x]:=0;
          end
         else
          begin
           turret[x,5]:=540-turret[x,5];
           turret[x,2]:= 470 - abs(turret[x,6]);
           angleinc[x]:=0;
          end;

     turret[x,1] := turret[x,1]+ round(turret[x,6]*
                 sin(turret[x,5]*pi/180)) div 2;
     turret[x,2] := turret[x,2]+ round(turret[x,6]
                 *cos(turret[x,5]*pi/180)) div 2;
     turret[x,3] := ROUND((tanksize-1) * SIN(turret[x,5] * PI / 180) + turret[x,1]);
     turret[x,4] := ROUND((tanksize-1) * COS(turret[x,5] * PI / 180) + turret[x,2]);
end;
{**************************************************************************}

procedure Countdown;
var
   count:integer;
   num:string;
begin
     ClearDevice;
     SetTextStyle(triplexfont,horizdir,7);
     SetTextJustify(centertext,toptext);
     Setcolor(blue);
     outtextxy(320,100,'Get Ready To Play!');
     count:=3;
     repeat
           setcolor(black);
           bar(300,200,400,300);
           setcolor(white);
           str(count,num);
           outtextxy(320,240,num);
           sound(1000); delay(20); nosound;
           count:=pred(count);
           delay(5000);
     until count=0;
     setcolor(red);
     SetTextStyle(triplexfont,horizdir,10);
     outtextxy(320,350,'GO!');
     sound(1500);delay(20);sound(2000);delay(20);nosound;
     delay(5000);
     end;

{**************************************************************************}
procedure MainLoop(player:longint);
var
   quit,StatusChange:boolean;    {the main game part}
   won,colour:integer;

begin
     Countdown;
     ClearDevice;
     SetupBoardPlrs;
     damage[1]:=attrib[1,1];
     damage[2]:=attrib[1,2];
     angleinc[1]:=0; angleinc[2]:=0;
     DrawTank(1,White,Blue);
     DrawTank(2,Blue,White);
     StatusUpdate;
     repeat
        KeyMove(quit,won,player);
        turret[1,5]:=turret[1,5]+angleinc[1];
        turret[2,5]:=turret[2,5]+angleinc[2];
           if not quit then
              begin
              DrawTank(1,green,green);
              DrawTank(2,green,green);
              ChkMovBounce(1);
              ChkMovBounce(2);
              bulletmove(StatusChange,won);
              minecheck(StatusChange,won);
              if StatusChange then
                 StatusUpdate;
              DrawTank(1,white,blue);
              DrawTank(2,blue,white);
              if player <> 0 then ai(player);
              delay(100);
           end;
     until Quit or (won=1) or (won=2);

     if won <> 0 then
        begin
           sound(3000);delay(100);sound(2000);delay(100);sound(1000);delay(200);
           sound(500);delay(500);nosound; delay(500);
           while keypressed do
             dummy :=readkey;
           SetTextJustify(CenterText,TopText);
           cleardevice;
           setbkcolor(black);
           repeat
              colour:=Random(15)+1;
              setcolor(colour);
              SetTextStyle(TriplexFont,HorizDir,15);   {Set text settings}
              outtextxy(GetMaxX div 2, 100,'Victory!');
              SetTextStyle(TriplexFont,HorizDir,7);   {Set text settings}
              outtextxy(GetMaxX div 2,275,names[won]);
              outtextxy(GetMaxX div 2,350,'is the winner!!!');
           until KeyPressed;
     end;
end;
{**************************************************************************}
{**************************************************************************}
procedure actualvalues;
  var
     diff,times:longint;    {convert to useable values}
     stt,sttt:string;   {dummies}
     exit :boolean;

  begin
    exit := false;
    for times := 1 to 2 do
        begin
          attrib[1,times] := stat[1,times] + 100;
          attrib[2,times] := stat[2,times] div 25 + 1;
          attrib[3,times] := stat[3,times] div 10 + 5;
        end;

    diff := stat[5,2] - stat[4,1];
    times := -10;  exit := false;
    repeat
        if diff < 10 * times then
           begin
             attrib[4,1] := (times + 11) *0.25;
             exit := true;
           end;
        times := times +1;
    until exit = true;

    {don't ask!!!!!!!}
    diff := stat[5,1] - stat[4,2];
    times := -10;  exit := false;
    repeat
        if diff < 10 * times then
           begin
             attrib[4,2] := (times + 11) *0.25;
             exit := true;
           end;
        times := times +1;
    until exit = true;

  end;
{**************************************************************************}

{**************************************************************************}
procedure chgrecord(files:filesarray; choice:longint);
   type
     copyarray = array[1..12] of string;
     goodarray = array[1..5] of longint;
     move1array = array[1..6,1..2] of longint;
     betterarray = array[1..5] of string;

   var
      indata,outdata:text;
      InputChar,yorn:char;
      x1,x2,y1,y2,empty,att,left,where,counter:longint;
      d1,d2,d3,dumb,realpassword,password:string;
      copy1:copyarray;
      good:goodarray;
      move1 : move1array;
      better:betterarray;

   begin
     restorecrtmode;
     {These are the y variables for the rectangle}
     for y1 := 1 to 5 do
       begin
         move1[y1,1] := 46 + 40 * y1;   {set up varibales}  {y1}
         move1[y1,2] := 59 + 40 * y1;                       {y2}
       end;

     y1 := 80;
     y2 := 105;

     att := 1;
     unencrypt(files[choice,2]);
     assign(indata,files[choice,2]);
     reset(indata);
     readln(indata);
     readln(indata);
     readln(indata);
     readln(indata);
     for counter := 1 to 5 do
        readln(indata,good[counter]);
     readln(indata,left);
     close(indata);
     dumb :=' ';
     for counter := 1 to 12 do
       copy1[counter] := '-99';

     clrscr;  where := 0;

     writeln('Enter personal password');
     realpassword := getpassword(1,2);
     assign(indata,files[choice,2]);
     reset(indata);
     readln(indata,password);
     readln(indata,password);
     close(indata);

     if realpassword = password then
       begin    {password good}
          writeln;
          writeln;
          writeln('Do you want to change your codename?   (Y or N)');
          readln(yorn);
          if upcase(yorn) = 'Y' then
            begin   {Y}
              where := 3;
              repeat
                    writeln;
                    writeln('Enter new codename');
                    readln(copy1[1]);
                    if length(copy1[1]) > 25 then
                      begin
                      writeln('Code name to long, enter a new one.');
                      delay(5000);
                    end;
              until length(copy1[1])<=25;
            end;   {Y}
          writeln;
          writeln('Do you want to change your password?   (Y or N)');
          readln(yorn);
          if upcase(yorn) = 'Y' then
            begin  {Y2}
              writeln;
              writeln('Enter new password');
              copy1[2] := getpassword(1,11 + where);
            end;  {Y2}

    setgraphmode(vgahi);
    cleardevice;     {set up the background}
    setcolor(blue);
    rectangle(150,75,510,310);
    setcolor(white);   setfillstyle(solidfill,red);
    rectangle(349,85,501,100);   outtextxy(175,90,'Extra Hit Points');
    rectangle(349,125,501,140);  outtextxy(175,130,'Acceleration');
    rectangle(349,165,501,180);  outtextxy(175,170,'Top speed');
    rectangle(349,205,501,220);  outtextxy(175,210,'Armor Strength');
    rectangle(349,245,501,260);  outtextxy(175,250,'Shot Power');
    outtextxy(302,290,'Quit');
    rectangle(124,350,526,365);
    setcolor(red);
    setfillstyle(solidfill,red);

    if left > 1 then
      begin
        rectangle(125,351,125+left,364);
        floodfill(126,355,red);
      end
    else line(125,351,125,364);

    for counter :=1 to 5 do
      begin   {counter0.5}
        if good[counter] > 1 then

          begin   {counter}
    setcolor(red);
    rectangle(350,46+ 40 * counter,350+good[counter],59+ 40 * counter);
    floodfill(351,50 + 40 * counter,red);
          end  {counter}

        else if good[counter] = 1 then
           begin    {counter1}
    setcolor(red);
    rectangle(350,46+ 40 * counter,350+good[counter],59+ 40 * counter);
           end;   {counter1}

      end;   {counter 0.5}

    repeat

     if keypressed then
         InputChar := readkey
     else
         InputChar := ' ';

     If InputChar=#0 then
      begin    {in1}
        InputChar := ReadKey;
        case InputChar of     {changes turret}
        'M':begin  {m1}
            if (att <> 6) and (left <> 0) then

             begin  {m2}
              setcolor(red);
              good[att] := good[att] + 1;
              empty := good[att];

              if good[att] > 150 then
                   good[att] := 150
              else
                begin {m3}
                  setcolor(red);
                  line(350+empty,move1[att,1],350+empty,move1[att,2]);
                  setcolor(black);
                  line(525-(400-left),351,525-(400-left),364);
                  left := left- 1;
                end;  {m3}
             end;  {m2}
           end;  {m1}

        'K':begin  {k2}
             if att <> 6 then
              begin  {k1}
                setcolor(black);
                empty := good[att];
                good[att] := good[att] - 1;

                if good[att] < 0 then
                     good[att] := 0
                else
                 begin   {c1}
                    setcolor(black);
                    line(350+empty,move1[att,1],350+empty,move1[att,2]);
                    setcolor(red);
                    line(525-(400-left),351,525-(400-left),364);
                    left := left +1;
                 end;    {c1}
              end;   {k1}
            end;   {k2}

        'H':begin    {up}
                 setcolor(black);
                 rectangle(x1,y1,x2,y2);
                 y1 := y1 - 40;      y2 := y2 - 40; att := att -1;
               end;    {up}

        'P':begin     {down}
                 setcolor(black);
                 rectangle(x1,y1,x2,y2);
                 y1 := y1 + 40;     y2 := y2 + 40;  att := att +1;
               end;     {down}
        end;   {case}
      end      {if1}
    else
        case InputChar of
             #13:if att = 6 then att := 7;
        end;     {case}

    if y1 < 75 then
      begin
         y1 := 280;   y2 := 305;  att := 6;
      end

      else if y1 > 305 then
        begin
          y1 := 80;  y2 := 105;  att := 1;
        end;

    setcolor(red);
    x1 := 165;
    x2 := 505;
    rectangle(x1,y1,x2,y2);

    until att = 7;

    {enter change stat code here}

    for counter := 1 to 5 do
      str(good[counter],better[counter]);

    for counter := 5 to 9 do
       copy1[counter] := better[counter-4];

    str(left,dumb);

    copy1[10] := dumb;

    assign(indata,files[choice,2]);
    reset(indata);
    for counter := 1 to 12 do
      if copy1[counter] = '-99' then
         readln(indata,copy1[counter])
      else
        readln(indata,dumb);
    close(indata);

    assign(outdata,files[choice,2]);
    rewrite(outdata);

    for counter := 1 to 12 do
      writeln(outdata,copy1[counter]);

    close(outdata);
    encrypt(files[choice,2]);

    {Remember to update the ply file}
    assign(indata,'filename.ply');
    reset(indata);
    assign(outdata,'filename.tmp');
    rewrite(outdata);
    repeat
    readln(indata,d1);
    readln(indata,d2);
    readln(indata,d3);
    if d1 = files[choice,1] then
       begin
         if copy1[1] <> '-99' then writeln(outdata,copy1[1])
         else writeln(outdata,d1);
         writeln(outdata,d2);
         writeln(outdata,d3);
       end
    else
     begin
      writeln(outdata,d1);
      writeln(outdata,d2);
      writeln(outdata,d3);
     end;
    until eof(indata);
    close(indata);
    close(outdata);
    erase(indata);
    rename(outdata,'filename.ply');
    end     {if password correct}

   else
      begin
        writeln;
        writeln('Invalid Password');
        delay(2000);
        encrypt(files[choice,2]);
        setgraphmode(vgahi);
      end;
    {if loaded change stats}

    if names[1] = files[choice,1] then
      begin
        for counter := 1 to 5 do
          stat[counter,1] := good[counter];
        if copy1[1] <> '-99' then
             names[1] := copy1[1]
      end
     else if names[2] = files[choice,1] then
      begin
        for counter := 1 to 5 do
          stat[counter,2] := good[counter];
        if copy1[1] <> '-99' then
             names[2] := copy1[1]
      end
 end;

{**************************************************************************}

{**************************************************************************}
procedure printplayers(command:integer);
   var
     files:filesarray;
     end1,counter,x1,y1,x2,y2:longint;
     winloss:string;
     choice,last,counter2 :longint;
     exit,good :boolean;
     InputChar:char;
     indata:text;

  begin
    choice := 1;  exit := false;   good := false;
    settextjustify(lefttext,toptext);
    settextstyle(DefaultFont,Horizdir,1);
    cleardevice;
    setcolor(blue);
    rectangle(150,120,490,345);
    assign(indata,'filename.ply');
    reset(indata);
    last := 0;

    repeat
        readln(indata);
        readln(indata);
        readln(indata);
        last := last + 1;
    until EOF(indata);
    close(indata);
    setcolor(green);
    outtextxy(175,130,'Player name');
    outtextxy(350,130,'Win / Loss');
    end1:= 0; x1 :=  165;   y1 :=  160;   x2 :=475;    y2 :=  190;
    assign(indata,'filename.ply');
    repeat
       reset(indata);
       if end1 <> 0 then
         for counter := 1 to end1 do
             begin
               readln(indata);  readln(indata);
               readln(indata);
             end;

        for counter := 1 to 4 do
            for counter2 := 1 to 3 do
                readln(indata,files[counter,counter2]);

        setcolor(white);
        for counter := 1 to 4 do
          begin
            outtextxy(175,125+50*counter,files[counter,1]);
            outtextxy(380,125+50*counter,files[counter,3]);
         end;

             if keypressed then
                 InputChar := readkey    {drawing}
             else
               InputChar := ' ';
             If InputChar=#0 then
               begin
                 InputChar := ReadKey;
                 case InputChar of     {changes turret}
                      'H':begin    {up}
                            setcolor(black);  rectangle(x1,y1,x2,y2);
                            choice := choice -1;
                            y1 := y1 - 50;      y2 := y2 - 50;
                          end;
                      'P':begin   {down}
                            setcolor(black);  rectangle(x1,y1,x2,y2);
                            choice := choice +1;
                            y1 := y1 + 50;     y2 := y2 + 50;
                          end;
                end; {case}
               end   {if}
             else
                 case InputChar of
                      #13:begin
                           exit := true;
                          end;
                 end;    {case}
         if y1 < 150 then
           begin
              y1 := 160;  y2 :=190;   end1 := end1 -1;
              setcolor(black);
              for counter := 1 to 4 do
                 begin
                    outtextxy(175,125+50*counter,files[counter,1]);
                    outtextxy(380,125+50*counter,files[counter,3]);
                 end;
              choice := 1;
           end;

        if y1 > 320 then
           begin
              y1 := 310;  y2 :=340;   end1 := end1 + 1;
              setcolor(black);
              for counter := 1 to 4 do
                  begin
                    outtextxy(175,125+50*counter,files[counter,1]);
                    outtextxy(380,125+50*counter,files[counter,3]);
                  end;
              choice := 4;
           end;
        if end1 < 0 then end1 := 0;
        if end1 > last-4 then end1 := last-4;

        setcolor(red);
        rectangle(x1,y1,x2,y2);

     until (exit = true) or (InputChar = #27);

    close(indata);
    if InputChar <> #27 then
    case choice of
      1:begin
          case command of
            1:loadrecord(files,choice);
            2:delrecord(files,choice,last);
            3:viewrecord(files,choice);
            4:chgrecord(files,choice);
          end;    {case}
        end;
      2:begin
          case command of
            1:loadrecord(files,choice);
            2:delrecord(files,choice,last);
            3:viewrecord(files,choice);
            4:chgrecord(files,choice);
          end;    {case}
        end;
      3:begin
          case command of
            1:loadrecord(files,choice);
            2:delrecord(files,choice,last);
            3:viewrecord(files,choice);
            4:chgrecord(files,choice);
          end;    {case}
        end;
      4:begin
          case command of
            1:loadrecord(files,choice);
            2:delrecord(files,choice,last);
            3:viewrecord(files,choice);
            4:chgrecord(files,choice);
          end;    {case}
        end;
    end;      {case}
  end;      {procedure}

{**************************************************************************}
procedure WinLoss;
{calls the 4   new,load,del,view}
   var
      choice2,x1,y1,x2,y2:integer;
      stt:string;
      InputChar:char;
      exit:boolean;

   begin   {procedure}
    for count := 1 to 5 do
        view[count] :=0;

    cleardevice;
    settextjustify(lefttext,toptext);
    settextstyle(DefaultFont,Horizdir,1);
    setcolor(blue);
    rectangle(200,155,400,320);
    setcolor(white);
    outtextxy(225,175,'Change Record');   {draw}
    outtextxy(225,215,'Load Record');
    outtextxy(225,255,'Delete Record');
    outtextxy(225,295,'View Records');
    x1 := 215;    y1 := 165;   x2 := 385;   y2 := 195;
    choice2 := 1;  exit := false;

    repeat

     if keypressed then
           InputChar := readkey   {get the key pressed}
       else
           InputChar := ' ';
       If InputChar=#0 then
          begin   {key}
            InputChar := ReadKey;
            case InputChar of     {changes turret}
                'H':begin
                      choice2 := choice2 - 1;
                      setcolor(black);
                      rectangle(x1,y1,x2,y2);
                      y1 := y1 - 40;   y2 := y2 -40;
                    end;
                'P':begin
                      choice2 := choice2 +1;
                      setcolor(black);
                      rectangle(x1,y1,x2,y2);
                      y1 := y1 + 40;   y2 := y2 + 40;
                    end;
            end;   {case}
          end    {key}
       else
         case InputChar of
            #13:exit := true;

         end;
     if choice2 > 4 then choice2 := 1;
     if choice2 < 1 then choice2 := 4;
     if y1 < 160 then
        begin
          y1 := 286;     y2 := 315;
          choice2 := 4;
        end;

    if y1 > 320 then
        begin
          y1 := 165;     y2 := 195;
          choice2 := 1;
        end;
    setcolor(red);
    rectangle(x1,y1,x2,y2);
  until (exit = true) or (InputChar = #27);

   if InputChar <> #27 then
    begin
    case choice2 of
       1:printplayers(4);
       2:printplayers(1);
       3:printplayers(2);
       4:printplayers(3);
    end;    {case}
    actualvalues;
    end;
   end;  {procedure}
{**************************************************************************}

{**************************************************************************}
procedure Instructions;   {instructions}
begin
    ClearDevice;
    SetTextStyle(TriplexFont,HorizDir,3);
    SetTextJustify(CenterText,TopText);
    SetColor(white);
    SetBkColor(Black);
    OutTextXY(320,0,'Pac-Tank: The Final Assault');
    OutTextXY(320,25,'Instructions');
    OutTextXY(100,60,'Player 1 Controls');
    OutTextXY(540,60,'Player 2 Controls');
    OutTextXY(100,100,'Up');
    OutTextXY(100,140,'Left      Right');
    OutTextXY(100,180,'Down');
    OutTextXY(100,220,'Return to Shoot');
    OutTextXY(540,100,'W');
    OutTextXY(540,140,'A    D');
    OutTextXY(540,180,'S');
    OutTextXY(540,220,'Space to Shoot');
    outtextxy(100,300,'Z for Mines');
    outtextxy(540,300,'+ for Mines');
    OutTextXY(320,375,'Escape to Quit Game');
    repeat
          SetColor(Black);
          Bar(0,450,640,480);
          SetColor(Random(15)+1);
          OutTextXY(320,450,'Press any key to continue...');
          delay(100);
    until KeyPressed;
end;
{**************************************************************************}

procedure endscreen;
var
   color:longint;

begin
textcolor(white);
Writeln('You have just finished playing the most thrilling action game ever.');
Writeln('Come back and play ''Pac-tank: The Final Assault'' whenever you what');
Writeln('to experence the never-ending action.');
Writeln;   textcolor(cyan);
Writeln('Pac-Tank: The Final Assault V',version);
Writeln;  textcolor(yellow);
Writeln('Programmers: Andrew Nichols, Terry Croteau, Robert Hancock');
writeln;
Writeln('Play Testers: Andrew Nichols, Terry Croteau, Danny Nichols, Lucas Preete,');
writeln('Robert Perreault, Jeremy Caissie, Robert Hancock');
writeln;
Writeln('Idea Men: Carey Underwood, Terry Croteau, Andrew Nichols, Robert Hancock,');
writeln('Jeremy Caissie');
writeln;  textcolor(lightred);
Writeln('This game was programmed in Turbo Pascal v4.0');
Writeln('Copyright (c) 1987 by Borland International, Inc.');
Writeln;   textcolor(7);
end;

{***************************************************************************}
begin    {main}
     write('Pac-Tank: The Final Assault V',version,' initializing..');
     for count := 1 to 3 do
        begin
          showstat[count,1] := ' ';
          showstat[count,2] := ' ';
        end;
     bullfx := false;   invismine := false;  plr1 := 'Human';
     plr2 := 'Human';  damage[1] := 0; damage[2] := 0;

     loaddef;
     if ErrorFlag then
        begin
        writeln;
        write('No files found or files corrupt, rewriting...');
        resetroster;
        loaddef;
        end;
     findstats;
     writeln;
     Randomize;
     GraphInit;
     StartScreen;   {what you choose}
     compplay:=0;
     repeat
          MainMenu(Option,plr1,plr2);
          case Option of
               1:begin
                  actualvalues;
                  MainLoop(compplay);
                  findstats;
                 end;
               2:Instructions;
               3:begin
                  ChgStuff;
                  actualvalues;
                 end;
               4:begin
                    WinLoss;
                    findstats;
                 end;
               6:begin
                   names[1] := 'Ultimate';
                   for count := 1 to 5 do
                       stat[count,1] := 300;
                 end;
               7:begin
                   names[2] := 'Otto the Viking';
                   for count := 1 to 5 do
                       stat[count,2] := 400;
                 end;
               -15:begin
                    if (plr1 = 'Human') and (plr2 = 'Human') then
                      begin
                        plr1 := 'Computer';
                        compplay := 1;
                        compplayer(1)
                      end
                    else if (plr1 = 'Computer') and (plr2 = 'Human') then
                      begin
                        plr1 := 'Human';
                        compplay := 0;
                        humanplayer(1)
                      end
                    else if (plr1 = 'Human') and (plr2 = 'Computer') then
                      begin
                        plr1 := 'Computer';   {use switch}
                        plr2 := 'Human';
                        compplay := 1;
                        switch
                      end
                  end;
               -14:begin
                    if (plr2 = 'Human') and (plr1 = 'Human') then
                      begin
                        plr2 := 'Computer';
                        compplay := 2;
                        compplayer(2)
                      end
                    else if (plr2 = 'Computer') and (plr1 = 'Human') then
                      begin
                        plr2 := 'Human';
                        compplay := 0;
                        humanplayer(2)
                      end
                    else if (plr2 = 'Human') and (plr1 = 'Computer') then
                      begin
                        plr2 := 'Computer';
                        plr1 := 'Human';   {use switch}
                        compplay := 2;
                        switch
                      end
                  end;
          end;
     until Option = 5;
     CloseGraph;
     endscreen;
end.